module.exports = {
  transform: {
    '.*\\.(vue)$': 'vue-jest',
    '^.+\\.tsx?$': 'ts-jest',
  },
  testRegex: '(/__tests__/.*|(\\.|/)(test|spec))\\.(ts?|tsx?)$',
  moduleFileExtensions: ['ts', 'tsx', 'js', 'json', 'jsx', 'vue'],
  automock: false,
  // bail: false,
  snapshotSerializers: ['jest-serializer-vue'],
  // moduleNameMapper: {
  // '^@/(.*)$': '<rootDir>/src/$1',
  // },
  globals: {
    'ts-jest': {
      diagnostics: false,
    },
    __DEV__: true,
  },
  // verbose: false,
  collectCoverage: true,
  testPathIgnorePatterns: ['/node_modules/', '.history', 'lib'],
  collectCoverageFrom: [
    '**/*.{ts,js,vue}',
    '!**/node_modules/**',
    '!jest.config.js',
    '!nuxt.config.js',
    '!modules/typescript.js',
    '!coverage/**',
    '!.nuxt/**',
    '!store/index.ts',
    '!./index.ts',
    '!.*',
    '!**/lib/**',
    '!*.d.ts',
  ],
  coverageThreshold: {
    global: {
      statements: 80, //テストされないステートメントの許容値
      branches: 55, // ifやcaseなどの全ての分岐の処理が実行されたか否か？
      functions: 75, //各関数が呼び出されたかの網羅率
      lines: 80, //ソースファイルの各実行可能行が実行されたか
    },
  },
  errorOnDeprecated: false,
}
