"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var js_base64_1 = require("js-base64");
var Encoder = /** @class */ (function () {
    function Encoder() {
    }
    Encoder.encode = function (json) {
        return js_base64_1.Base64.encode(JSON.stringify(json));
    };
    Encoder.decode = function (str) {
        try {
            var decodingData = js_base64_1.Base64.decode(str);
            var json = JSON.parse(decodingData);
            return json;
        }
        catch (e) {
            console.error('Decoding error', e);
            return { success: false, error: e.code };
        }
    };
    Encoder.toWebAppsApiKeyFromBase64 = function (str) {
        var encodedData = this.decode(str);
        if ('apiKey' in encodedData &&
            'projectId' in encodedData &&
            'authDomain' in encodedData) {
            return encodedData;
        }
        console.warn('Failed decoding Web apps api key');
        return __assign({ apiKey: 'error or empty', projectId: 'error or empty', authDomain: 'error or empty' }, encodedData);
    };
    Encoder.toAccountKeyFromBase64 = function (str) {
        var encodedData = this.decode(str);
        if ('project_id' in encodedData &&
            'type' in encodedData &&
            'client_id' in encodedData) {
            return encodedData;
        }
        console.warn('Failed decoding service account key');
        console.info('encodedData', encodedData);
        return __assign({ project_id: 'error or empty', client_id: 'error or empty', type: 'error or empty' }, encodedData);
    };
    return Encoder;
}());
exports.default = Encoder;
