import Encoder from '../Encoder'
const testAccountKeyJson = require('../../.keys/shirahama-test-d6301-b798cfcf7b07.json')

describe('Encoder', () => {
  test('typecheck', () => {
    expect(Encoder.encode).toBeInstanceOf(Function)
    expect(Encoder.decode).toBeInstanceOf(Function)
  })
  test('encode', () => {
    const encodedData: string = Encoder.encode(testAccountKeyJson)
    expect(encodedData).toEqual(expect.any(String))
  })
  test('encode => decode', () => {
    const encodedData = Encoder.encode(testAccountKeyJson)
    const decodedData = Encoder.decode(encodedData)
    expect(decodedData).toBeInstanceOf(Object)
    expect(decodedData).toEqual(testAccountKeyJson)
  })
  test('toAccountKeyFromBase64', () => {
    const encodedData: string = Encoder.encode(testAccountKeyJson)
    const accountKey = Encoder.toAccountKeyFromBase64(encodedData)
    expect(accountKey.project_id).toEqual(expect.any(String))
    expect(accountKey.type).toEqual(expect.any(String))
    expect(accountKey.client_id).not.toEqual('error or empty')
    expect(accountKey.type).not.toEqual('error or empty')
  })
  test('failed: decode', () => {
    console.error = jest.fn()
    const decodedData = Encoder.decode('FAILED_TEXT')
    // @ts-ignore
    expect(decodedData.success).toEqual(false)
    expect(console.error).toHaveBeenCalled()
  })
  test('failed: toWebAppsApiKeyFromBase64', () => {
    console.error = jest.fn()
    console.warn = jest.fn()
    const apiKey = Encoder.toWebAppsApiKeyFromBase64('FAILED_TEXT')
    expect(apiKey.apiKey).toEqual('error or empty')
  })
})
